//go:build !disable_format_vorbis && !disable_codec_libvorbis && cgo

package vorbis

import (
	"git.gammaspectra.live/S.O.N.G/Kirika/audio/format/flac"
	"git.gammaspectra.live/S.O.N.G/Kirika/test"
	"os"
	"testing"
)

func TestEncodeVorbis(t *testing.T) {
	fp, err := os.Open(test.TestSingleSample24)
	if err != nil {
		t.Error(err)
		return
	}
	defer fp.Close()
	source, err := flac.NewFormat().Open(fp)
	if err != nil {
		t.Error(err)
		return
	}

	target, err := os.CreateTemp("/tmp", "encode_test_*.vorbis")
	if err != nil {
		t.Error(err)
		return
	}

	defer func() {
		name := target.Name()
		target.Close()
		os.Remove(name)
	}()

	options := make(map[string]interface{})
	options["bitrate"] = "128k"

	err = NewFormat().Encode(source, target, options)
	if err != nil {
		t.Error(err)
		return
	}
}
