package packetizer

type KeepMode int

const (
	KeepLast = KeepMode(iota)
	Keep
	GroupKeep
	GroupDiscard
	Discard
)

type Packet interface {
	KeepMode() KeepMode
	Category() int64
	GetStartSampleNumber() int64
	GetEndSampleNumber() int64
	GetData() []byte
}

type OffsetablePacket interface {
	Packet
	GetDataOffset(offset int64) []byte
}

type Packetizer interface {
	GetPacket() Packet
}
